// god i hate math
// -lSDL2 -lm

#include <SDL2/SDL.h>
#include <stdio.h>
#include <math.h>

#define guard(cond) do { if (cond) { fprintf(stderr, #cond ": %s\n", SDL_GetError()); return NAN; } } while (0)
#define clear do { guard(SDL_SetRenderDrawColor(renderer, 0xFF, 0xFF, 0xFF, 0xFF) < 0); guard(SDL_RenderClear(renderer) < 0); guard(SDL_SetRenderDrawColor(renderer, 0x00, 0x00, 0x00, 0xFF) < 0); } while (0)
#define line(x, y, ex, ey) guard(SDL_RenderDrawLine(renderer, x, y, ex, ey) < 0)

int const WIDTH = 1920;
int const HEIGHT = 1080;

double entry(double* a, double* b, size_t len) {
    guard(SDL_Init(SDL_INIT_VIDEO) < 0);

    SDL_Window* window = SDL_CreateWindow("inter.c", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, WIDTH, HEIGHT, SDL_WINDOW_SHOWN);
    guard(!window);

    SDL_Renderer* renderer = SDL_CreateRenderer(window, -1, 0);
    guard(!renderer);

    clear;
    line(WIDTH / 2 - 500, HEIGHT / 2, WIDTH / 2 + 499, HEIGHT / 2);
    SDL_RenderPresent(renderer);

    printf("A ruler and a protractor are required to use this program.\n");
    printf("Enter the length of this line in any unit. The more precision, the better: ");
    double l;
    scanf("%lf", &l);
    double r = 1000.0 / l;

    clear;
    line(WIDTH / 2, HEIGHT / 2 - 500, WIDTH / 2, HEIGHT / 2 + 499);
    SDL_RenderPresent(renderer);

    double prod = 0.0;

    for (size_t i = 0; i < len; i += 2) {
        // base case
        if (i+1 == len) {
            prod += a[i]*b[i];
            continue;
        }

        double x1 = a[i], y1 = a[i+1],
               x2 = b[i], y2 = b[i+1];

        double brx1 = (WIDTH - 80.0) / fabs(x1) / 2.0;
        double brx2 = (WIDTH - 80.0) / fabs(x2) / 2.0;
        double bry1 = (HEIGHT - 80.0) / fabs(y1) / 2.0;
        double bry2 = (HEIGHT - 80.0) / fabs(y2) / 2.0;
        double brx = brx1 < brx2 ? brx1 : brx2;
        double bry = bry1 < bry2 ? bry1 : bry2;
        double br = brx < bry ? brx : bry;

        clear;
        line(WIDTH / 2, HEIGHT / 2, WIDTH/2 + (int)(x1*br), HEIGHT/2 + (int)(y1*br));
        line(WIDTH / 2, HEIGHT / 2, WIDTH/2 + (int)(x2*br), HEIGHT/2 + (int)(y2*br));
        SDL_RenderPresent(renderer);

        double line1, line2, angle;
        printf("Enter the length of one of the lines, in the same unit: ");
        scanf("%lf", &line1);
        printf("And the other: ");
        scanf("%lf", &line2);
        printf("The angle between them, in degrees: ");
        scanf("%lf", &angle);

        prod += line1 * r / br * line2 * r / br * cos(angle * (M_PI / 180.0));
    }

    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(window);
    SDL_Quit();
    printf("The dot product is %lf", prod);
    return prod;
}
